package com.bigdata.wxappserver.enums;

import com.bigdata.wxappserver.utils.EnumUtil;
import lombok.Getter;

import javax.swing.text.html.Option;
import java.util.Objects;
import java.util.Optional;

@Getter
public enum OrderStatusEnum {

    NON_PAYMENT(1,"待付款"),
    NON_ORDER(2,"待接单"),
    ORDERED(3,"已接单"),
    DELIVERY(4,"派送中"),
    FINISHED(5,"已完成"),
    CANCELED(6,"已取消");
    private Integer id;
    private String description;

     OrderStatusEnum(Integer id,String description){
        this.id=id;
        this.description=description;
    }

    public static Optional<OrderStatusEnum> valueOf(Integer id){
         return EnumUtil.getEnumObject(OrderStatusEnum.class,e-> Objects.equals(e.getId(),id));
    }

    public static String describe(Integer id){
         return valueOf(id).map(OrderStatusEnum::getDescription).orElse("");
    }

}
