package com.bigdata.wxappserver.utils;

import java.util.Arrays;
import java.util.Map;
import java.util.Optional;
import java.util.concurrent.ConcurrentHashMap;
import java.util.function.Predicate;

/**
 * 枚举工具类
 */
public class EnumUtil {

    private static Map<Class,Object> map=new ConcurrentHashMap<>(16);

    public static <T> Optional<T> getEnumObject(Class<T> clazz, Predicate<T> predicate){
        if(!clazz.isEnum()){
            return Optional.empty();
        }
        Object object = map.get(clazz);
        T[] tArr=null;
        if(object ==null){
            tArr = clazz.getEnumConstants();
            map.put(clazz,tArr);
        }else{
            tArr= (T[]) object;
        }
        return Arrays.stream(tArr).filter(predicate).findFirst();
    }

}
